-- name: [CS] Biker Wario
-- description: Adds the rough-and-tough biker outfit Wario dons in the WarioWare series! \nRequires Character Select. \nMade By BuckleyTim.

local E_MODEL_WARIO_BIKER = smlua_model_util_get_id("wario_biker_geo")

local TEXT_MOD_NAME = "Biker Wario"

local TEX_WARIO_BIKER = get_texture_info("icon_ww_wario")

local VOICETABLE_WARIO_BIKER = {
    [CHAR_SOUND_ATTACKED] = "Wario_Scream04.ogg",
    [CHAR_SOUND_GROUND_POUND_WAH] = "Wario_Wah.ogg",
    [CHAR_SOUND_HAHA] = "Wario_HaHAHA.ogg",
    [CHAR_SOUND_HAHA_2] = "Wario_HaHAHA.ogg",
    [CHAR_SOUND_HERE_WE_GO] = "Wario_Yahoo01.ogg",
    [CHAR_SOUND_HOOHOO] = "Wario_Okay.ogg",
    [CHAR_SOUND_ON_FIRE] = "Wario_Scream03.ogg",
    [CHAR_SOUND_OOOF] = "Wario_Hey.ogg",
    [CHAR_SOUND_OOOF2] = "Wario_Hey.ogg",
    [CHAR_SOUND_PUNCH_HOO] = "Wario_Yeah01.ogg",
    [CHAR_SOUND_PUNCH_WAH] = "Wario_Wow.ogg",
    [CHAR_SOUND_PUNCH_YAH] = "Wario_Ah.ogg",
    [CHAR_SOUND_SO_LONGA_BOWSER] = "Wario_ByeBye.ogg",
    [CHAR_SOUND_TWIRL_BOUNCE] = "Wario_HurryUp01.ogg",
    [CHAR_SOUND_WAAAOOOW] = "Wario_Scream02.ogg",
    [CHAR_SOUND_WAH2] = "Wario_Wah.ogg",
    [CHAR_SOUND_WHOA] = "Wario_OhBoy01.ogg",
    [CHAR_SOUND_YAHOO] = "Wario_Excellent01.ogg",
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = {"Wario_Excellent01.ogg", "Wario_Alright01.ogg"},
    [CHAR_SOUND_YAH_WAH_HOO] = {"Wario_Ah.ogg", "Wario_Wow.ogg", "Wario_Yeah01.ogg"},
    [CHAR_SOUND_OKEY_DOKEY] = "Wario_GoodLuck01.ogg",
    [CHAR_SOUND_LETS_A_GO] = "Wario_Hereigo01.ogg",
    [CHAR_SOUND_DYING] = "Wario_HAHAHAHAAH.ogg",
    [CHAR_SOUND_DROWNING] = "Wario_HAHAHAHAAH.ogg",
    [CHAR_SOUND_EEUH] = "Wario_Okay.ogg",
    [CHAR_SOUND_MAMA_MIA] = "Wario_MamaMia01.ogg",
    [CHAR_SOUND_DOH] = "Wario_Nono.ogg",
    [CHAR_SOUND_HRMM] = "Wario_Ah.ogg",
    [CHAR_SOUND_PANTING] = "Wario_Ah.ogg",
    [CHAR_SOUND_UH] = "Wario_Ah.ogg",
}

local MODEL_CAPS_WARIO_BIKER = {
    normal = smlua_model_util_get_id("wario_biker_cap_geo"),
    wing = smlua_model_util_get_id("wario_biker_cap_W_geo"),
    metal = smlua_model_util_get_id("wario_biker_cap_M_geo"),
    metalWing = smlua_model_util_get_id("wario_biker_cap_W_M_geo")
}

-- pants 62AADF
-- shirt 3255A5
-- cap FFF14C
-- gloves FFF14C
-- shoes EB95BF
-- hair DB622B
-- skin FEC179

local PALLETE_WARIO_BIKER = {
    [PANTS]  = {r = 0x62, g = 0xaa, b = 0xdf},
    [SHIRT]  = {r = 0x32, g = 0x55, b = 0xa5},
    [GLOVES] = {r = 0xff, g = 0xf1, b = 0x4c},
    [SHOES]  = {r = 0xeb, g = 0x95, b = 0xbf},
    [HAIR]   = {r = 0xdb, g = 0x62, b = 0x2b},
    [SKIN]   = {r = 0xfe, g = 0xc1, b = 0x79},
    [CAP]    = {r = 0xff, g = 0xf1, b = 0x4c},
    }


-- add it
if _G.charSelectExists then
    _G.charSelect.character_add("Biker Wario", {"Wario's biker persona","from the WarioWare series."}, "BuckleyTim", {r = 255, g = 255, b = 0}, E_MODEL_WARIO_BIKER, CT_WARIO, TEX_WARIO_BIKER)

    _G.charSelect.character_add_caps(E_MODEL_WARIO_BIKER, MODEL_CAPS_WARIO_BIKER)

    _G.charSelect.character_add_voice(E_MODEL_WARIO_BIKER, VOICETABLE_WARIO_BIKER)


    hook_event(HOOK_CHARACTER_SOUND, function (m, sound)
        if _G.charSelect.character_get_voice(m) == VOICETABLE_WARIO_BIKER then return _G.charSelect.voice.sound(m, sound) end
    end)

    hook_event(HOOK_MARIO_UPDATE, function (m)
        if _G.charSelect.character_get_voice(m) == VOICETABLE_WARIO_BIKER then return _G.charSelect.voice.snore(m) end
    end)

    _G.charSelect.character_add_palette_preset(E_MODEL_WARIO_BIKER, PALLETE_WARIO_BIKER)

else
    djui_popup_create("\\#ffffdc\\\n"..TEXT_MOD_NAME.."\nRequires the Character Select Mod\nto use as a Library!\n\nPlease turn on the Character Select Mod\nand Restart the Room!", 6)
end